////////////////////////////////////////////////////////////////////////////////
//                       zVolume 1.1 - Aston Plug-in
//                       by ZealotSix (Travis Collins)
//                           travistx@gmail.com
////////////////////////////////////////////////////////////////////////////////
// Changelog
////////////////////////////////////////////////////////////////////////////////
//
// 1.1:    6/24/06
//      Added hand mouse cursor when the mouse is over the sliders or
//            mute buttons
//      Added WM_LBUTTONDN and WM_NCLBUTTONDN event handler
//            This allows the volume to be changed if someone clicks without
//            sending a WM_MOUSEMOVE event.
//
//
//
// 1.0:    6/21/06
//      public release
//
///////////////////////////////////////////////////////////////////////////////

library zVolume;

uses
  Windows,
  Messages,
  shellapi,
  MMSystem,
  drawpng in '..\drawpng.pas',
  FNxxx in '..\FNxxx.pas',
  AstonSDK in '..\AstonSDK.pas',
  st_api in '..\st_api.pas',
  mix_engine in 'mix_engine.pas';

{---------------------------------------------------------------------}



{$IFDEF Debug}
{$E .plg}
{$ELSE}
{$I ..\plg.pas}
{$ENDIF}

{$IMAGEBASE $00400000}

function ReadConfig():bool;forward;
procedure SaveConfig;forward;
procedure AstonMB(sMessage: string);forward;
procedure DoneModule; stdcall;forward;
procedure InitGlobalModule(const AstonData:PAstonData); stdcall;forward;
procedure DrawXP();forward;
procedure DrawSliders(DC: hDC);forward;
procedure DrawMuteButtons(DC: hDC);forward;
{---------------------------------------------------------------------}

const
 szClassName = 'zVolume';
 //szHelp - what is shown in the "Properties" dialog
 szHelp:PChar = 'zVolume 1.1'#13#10'by ZealotSix'#13#10'http://www.visualinfusion.com';

  CM_APPBAR = WM_USER+2;
  AC_SRC_ALPHA =1;
  ULW_ALPHA = 2;

 //keynames, and the hint text also

  cOrientations = 1;
  vOrientations:array[0..cOrientations] of PChar=('Horizontal', 'Vertical');

  cControls = 9;
  vControls:array[0..cControls] of PChar=('None', 'Master', 'Wave', 'CD', 'MIDI', 'AUX', 'Line In',
    'Digital',
    'Microphone',
    'Analog'
  );

  mixers:array[0..cControls] of integer=(
    -1,
    MIXERLINE_COMPONENTTYPE_DST_SPEAKERS,
    MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT,
    MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC,
    MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER,
    MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY,
    MIXERLINE_COMPONENTTYPE_SRC_LINE,
    MIXERLINE_COMPONENTTYPE_SRC_DIGITAL,
    MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE,
    MIXERLINE_COMPONENTTYPE_SRC_ANALOG
  );

  szXPos = 'X';
  szYPos = 'Y';
  szLock = 'Locked';
  szSkin = 'Background Skin';
  szSliderSkin = 'Slider Skin';
  szMuteSkin = 'Mute Skin';
  szSliderFrameCount = 'Slider FrameCount';
  szOrientation = 'Slider Orientation';

  szControl1 = 'Volume Control 1';
  szControl1X = 'Slider 1 X';
  szControl1Y = 'Slider 1 Y';
  szMute1X = 'Mute 1 X';
  szMute1Y = 'Mute 1 Y';

  szControl2 = 'Volume Control 2';
  szControl2X = 'Slider 2 X';
  szControl2Y = 'Slider 2 Y';
  szMute2X = 'Mute 2 X';
  szMute2Y = 'Mute 2 Y';

  szControl3 = 'Volume Control 3';
  szControl3X = 'Slider 3 X';
  szControl3Y = 'Slider 3 Y';
  szMute3X = 'Mute 3 X';
  szMute3Y = 'Mute 3 Y';

  szControl4 = 'Volume Control 4';
  szControl4X = 'Slider 4 X';
  szControl4Y = 'Slider 4 Y';
  szMute4X = 'Mute 4 X';
  szMute4Y = 'Mute 4 Y';


  //KeyCount - how many keys total
  KeyCount = 32;

 //Keys - the actual array of keys used in the plugin info
  Keys: array[1..KeyCount] of TKey = (
    (szKey:szXPos; nType:KEY_INT;  szHint: szXPos; vDefault: 10; res1:0; res2:0),
    (szKey:szYPos; nType:KEY_INT;  szHint: szYPos; vDefault: 10; res1:0; res2:0),
    (szKey:szLock; nType:KEY_BOOL;  szHint: szLock; vDefault: 0; res1:0; res2:0),
    (szKey:szSkin; nType:KEY_PATH; szHint: szSkin; vDefault: 0; res1:0; res2:0),
    (szKey:szSliderSkin; nType:KEY_PATH; szHint: szSliderSkin; vDefault: 0; res1:0; res2:0),
    (szKey:szSliderFrameCount; nType:KEY_INT;  szHint: szSliderFrameCount; vDefault: 0; res1:0; res2:0),
    (szKey:szMuteSkin; nType:KEY_PATH; szHint: szMuteSkin; vDefault: 0; res1:0; res2:0),
    (szKey:szOrientation; nType:KEY_LIST;  szHint: szOrientation; vDefault: 0; res1:cOrientations; res2:0),

    (szKey:nil; nType:KEY_CAPTION; szHint:'Volume Control 1'; vDefault: 0; res1:0; res2:0),
    (szKey:szControl1; nType:KEY_LIST;  szHint: szControl1; vDefault: 1; res1:cControls; res2:0),
    (szKey:szControl1X; nType:KEY_INT;  szHint: szControl1X; vDefault: 0; res1:0; res2:0),
    (szKey:szControl1Y; nType:KEY_INT;  szHint: szControl1Y; vDefault: 0; res1:0; res2:0),
    (szKey:szMute1X; nType:KEY_INT;  szHint: szMute1X; vDefault: 0; res1:0; res2:0),
    (szKey:szMute1Y; nType:KEY_INT;  szHint: szMute1Y; vDefault: 0; res1:0; res2:0),

    (szKey:nil; nType:KEY_CAPTION; szHint:'Volume Control 2'; vDefault: 0; res1:0; res2:0),
    (szKey:szControl2; nType:KEY_LIST;  szHint: szControl2; vDefault: 2; res1:cControls; res2:0),
    (szKey:szControl2X; nType:KEY_INT;  szHint: szControl2X; vDefault: 10; res1:0; res2:0),
    (szKey:szControl2Y; nType:KEY_INT;  szHint: szControl2Y; vDefault: 10; res1:0; res2:0),
    (szKey:szMute2X; nType:KEY_INT;  szHint: szMute2X; vDefault: 0; res1:0; res2:0),
    (szKey:szMute2Y; nType:KEY_INT;  szHint: szMute2Y; vDefault: 0; res1:0; res2:0),

    (szKey:nil; nType:KEY_CAPTION; szHint:'Volume Control 3'; vDefault: 0; res1:0; res2:0),
    (szKey:szControl3; nType:KEY_LIST;  szHint: szControl3; vDefault: 3; res1:cControls; res2:0),
    (szKey:szControl3X; nType:KEY_INT;  szHint: szControl3X; vDefault: 10; res1:0; res2:0),
    (szKey:szControl3Y; nType:KEY_INT;  szHint: szControl3Y; vDefault: 10; res1:0; res2:0),
    (szKey:szMute3X; nType:KEY_INT;  szHint: szMute3X; vDefault: 0; res1:0; res2:0),
    (szKey:szMute3Y; nType:KEY_INT;  szHint: szMute3Y; vDefault: 0; res1:0; res2:0),

    (szKey:nil; nType:KEY_CAPTION; szHint:'Volume Control 4'; vDefault: 0; res1:0; res2:0),
    (szKey:szControl4; nType:KEY_LIST;  szHint: szControl4; vDefault: 4; res1:cControls; res2:0),
    (szKey:szControl4X; nType:KEY_INT;  szHint: szControl4X; vDefault: 10; res1:0; res2:0),
    (szKey:szControl4Y; nType:KEY_INT;  szHint: szControl4Y; vDefault: 10; res1:0; res2:0),
    (szKey:szMute4X; nType:KEY_INT;  szHint: szMute4X; vDefault: 0; res1:0; res2:0),
    (szKey:szMute4Y; nType:KEY_INT;  szHint: szMute4Y; vDefault: 0; res1:0; res2:0)
  );

var

 UpdateLayeredWindow: function(hWnd:HWND; hdcDst:HDC;
       pptDst:pPOINT; psize:pSIZE; hdcSrc:HDC; pptSrc:pPOINT;
       crKey:TCOLORREF; pblend:pBLENDFUNCTION;
       dwFlags: DWORD):BOOL; stdcall;

  PluginInfo:TPluginInfo;
  AData: TAstonData;
  Wnd: hWnd=0;
  ClientRC: TRect;

  cfgSkin: array[0..MAX_PATH] of char;
  cfgSliderSkin: array[0..MAX_PATH] of char;
  cfgSliderFrameCount: integer;
  cfgMuteSkin: array[0..MAX_PATH] of char;
  cfgOrientation: integer;
  cfgX, cfgY: integer;
  cfgLock:boolean;        //cfgLock:
                          //  0 = Unlocked
                          //  1 = Locked

  cfgControl: array[1..4] of integer;
  cfgSliderX: array[1..4] of integer;
  cfgSliderY: array[1..4] of integer;
  cfgMuteX: array[1..4] of integer;
  cfgMuteY: array[1..4] of integer;


  picSkin: TPicture;
  picSliderSkin: TPicture;
  picMuteSkin: TPicture;
  iSliderWidth: integer;
  iMuteWidth: integer;

  isXp, isPNG:bool;

  layered: UINT = 0;


  ZOrder:integer;             //ZOrder:
                              //  0 = Desktop
                              //  1 = Normal
                              //  2 = Always On Top



  bd: ShellAPI.TAPPBARDATA;
  Mode:DWORD;
  Timer: integer;
 {---------------------------------------------------------------------}

//////////////////////////////////////////////////////////////////
//   procedure Draw                                             //
//                                                              //
//   Draws the window.  Called from W_PAINT when using non-     //
//     layered window.                                          //
//////////////////////////////////////////////////////////////////
procedure Draw(DC: hDC);
var
  r,r2:Trect;
  uFlags:UINT;
  memDC: hDC;
  memBmp: HBitmap;
  OldmemBmp:HGDIOBJ;
begin
  memDC:=CreateCompatibleDC(DC);
  memBmp:=CreateCompatibleBitmap(DC, picSkin.Width, picSkin.Height);
  OldmemBmp:=SelectObject(memDC, memBmp);


  if mode=0 then
  begin
    GetWindowRect(Wnd, r);
    SetRect(r2, 0,0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
    uFlags:= DPEx_CORRECTBRUSH;
    with AData.WallPaperInfo do
    begin
      if TileWallpaper<>0 then uFlags:= uFlags or DPEx_TILED;
      if WallpaperStyle=0 then uFlags:= uFlags or DPEx_CENTERED;
      DrawSkin(memDC, memDC, ClientRC, r, r2, Wallpaper, DesktopBrush, uFlags);
    end;
  end;

  DrawPicture(memDC, memDC, 0,0, @picSkin);
  DrawSliders(memDC);
  DrawMuteButtons(memDC);
  BitBlt(DC,0,0,picSkin.Width, picSkin.Height,memDC,0,0,SRCCOPY);
  selectobject(memDC, OldmemBmp);
  DeleteObject(memBmp);
  DeleteObject(OldmemBmp);
  DeleteDC(memDC);
end;

procedure UpdateCursor();
var
  cursor: HICON;
  P : TPoint;
  r:Trect;
  i: integer;
begin
  GetWindowRect(Wnd, r);
  GetCursorPos(P);


  // Are we on a slider?
  for i := 1 to 4 do
  begin
    if ((cfgControl[i] <> 0) and
       (P.X >= r.Left + cfgSliderX[i]) and
       (P.X <= r.Left + cfgSliderX[i] + iSliderWidth) and
       (P.Y >= r.Top + cfgSliderY[i]) and
       (P.Y <= r.Top + cfgSliderY[i] + picSliderSkin.Height)) then
    begin
      cursor := LoadCursor(0, IDC_HAND);
      SetCursor(cursor);
      exit;
    end;
  end;

  // Are we on a mute button?
  for i := 1 to 4 do
  begin
    if ((cfgControl[i] <> 0) and
       (P.X >= r.Left + cfgMuteX[i]) and
       (P.X <= r.Left + cfgMuteX[i] + iMuteWidth) and
       (P.Y >= r.Top + cfgMuteY[i]) and
       (P.Y <= r.Top + cfgMuteY[i] + picMuteSkin.Height)) then
    begin
      cursor := LoadCursor(0, IDC_HAND);
      SetCursor(cursor);
      exit;
    end;
  end;


end;

//////////////////////////////////////////////////////////////////
//   function WindowProc                                        //
//                                                              //
//   Process windows messages                                   //
//////////////////////////////////////////////////////////////////
function WindowProc(Window: HWnd; Message:UINT; WParam: WParam; LParam: LParam): Longint;  stdcall;
const
  SC_MenuItem1 = WM_USER + 1;
  SC_MenuItem2 = WM_USER + 2;
var
  DC: hDC;
  ps: TPaintStruct;
  r:Trect;
  iVolume: integer;
  P : TPoint;
  i: integer;
  PopMenu : HMenu; 
  szSetup: array[0..MAX_PATH+1] of char;
begin
  result := 0;

  case Message of
    WM_TIMER:
    begin
      // Update the display.

      // But only if the mouse button is up, or if we don't have focus
      // this is to prevent  the window from jumping while the user is trying to drag it
      if ((GetAsyncKeyState(VK_LBUTTON)and $8000)=0) or (GetActiveWindow()<>Wnd)  then
      begin
        if mode=1 then DrawXP()
        else InvalidateRect(Wnd, nil, true);
        exit;
      end;
    end;

    WM_LBUTTONUP,
    WM_NCLBUTTONUP:
    begin
      GetWindowRect(Window, r);
      GetCursorPos(P);
      // Are we on a mute button?
      for i := 1 to 4 do
      begin
        if ((P.X >= r.Left + cfgMuteX[i]) and
           (P.X <= r.Left + cfgMuteX[i] + iMuteWidth) and
           (P.Y >= r.Top + cfgMuteY[i]) and
           (P.Y <= r.Top + cfgMuteY[i] + picMuteSkin.Height)) then
        begin
          SetVolumeMute(mixers[cfgControl[i]], not GetVolumeMute(mixers[cfgControl[i]]));
          if mode=1 then DrawXP()
            else InvalidateRect(Wnd, nil, true);
        end;
      end;
    UpdateCursor();
    end;

    //////////////////////////////////
    // WM_RBUTTONUP                 //
    //                              //
    // Right Mouse Click            //
    // Popup Menu                   //
    //////////////////////////////////
    WM_RBUTTONUP,
    WM_NCRBUTTONUP:
    begin
      PopMenu := CreatePopupMenu;

      // Create Popup Menu
      AppendMenu(PopMenu, MF_STRING, SC_MenuItem1, 'Configure zVolume');

      // Show Popup Menu
      GetCursorPos(p);
      TrackPopupMenu(PopMenu, TPM_LEFTALIGN, p.X, p.y, 0, Window, nil);
      DestroyMenu(PopMenu);
      result := 0;
      exit;
    end;

    //////////////////////////////////
    // WM_COMMAND                   //
    //                              //
    // Menu Item was chosen         //
    //////////////////////////////////
    WM_COMMAND:
    begin
      case LOWORD(wParam) of
        SC_MenuItem1:   // Configure Plug-in
        begin
          szSetup[0] := '/';
          lstrcpy(@szSetup[1], Adata.Node.Path);
          SendMessage(Adata.MainWindow, CM_SETUPASTON, 0, integer(@szSetup[0]));
        end;
        SC_MenuItem2:   // About
        begin
          AstonMB(szHelp);
        end;
      end;
    end;

    //////////////////////////////////
    // WM_PAINT                     //
    //                              //
    // Only used with non-layered   //
    //  windows                     //
    //////////////////////////////////
    WM_PAINT:
    begin
      DC:=BeginPaint(Window, ps);
      Draw(DC);
      EndPaint(Window, ps);
      exit;
    end;


    //////////////////////////////////
    // WM_EXITSIZEMOVE              //
    //                              //
    // Save coordinates when we're  //
    // done moving                  //
    //////////////////////////////////
    WM_EXITSIZEMOVE:
    begin
      SaveConfig;
    end;


    //////////////////////////////////
    // WM_NCHITTEST                 //
    //                              //
    // Only allow dragging of       //
    // window when mouse is not     //
    // over a slider                //
    //////////////////////////////////
    WM_NCHITTEST:
    begin


      // If the window is locked, no need to go on
      if cfgLock and ((GetAsyncKeyState(VK_SHIFT)and $8000)=0) then
      begin
          // return HTCLIENT (can't drag window around)
          DefWindowProc(Window, Message, WParam, LParam);
          result:=HTCLIENT;
          exit;
      end;

      GetWindowRect(Window, r);
      GetCursorPos(P);

      // Are we on a slider?
      for i := 1 to 4 do
      begin
        if ((P.X >= r.Left + cfgSliderX[i]) and
           (P.X <= r.Left + cfgSliderX[i] + iSliderWidth) and
           (P.Y >= r.Top + cfgSliderY[i]) and
           (P.Y <= r.Top + cfgSliderY[i] + picSliderSkin.Height)) then
        begin
          // return HTCLIENT (can't drag window around)
          DefWindowProc(Window, Message, WParam, LParam);
          result:=HTCLIENT;
          exit;
        end;
      end;

      // Are we on a mute button?
      for i := 1 to 4 do
      begin
        if ((P.X >= r.Left + cfgMuteX[i]) and
           (P.X <= r.Left + cfgMuteX[i] + iMuteWidth) and
           (P.Y >= r.Top + cfgMuteY[i]) and
           (P.Y <= r.Top + cfgMuteY[i] + picMuteSkin.Height)) then
        begin
          // return HTCLIENT (can't drag window around)
          DefWindowProc(Window, Message, WParam, LParam);
          result:=HTCLIENT;
          exit;
        end;
      end;


      // return HTCAPTION (allow dragging)
      DefWindowProc(Window, Message, WParam, LParam);
      result:=HTCAPTION;
      exit;
    end;


    //////////////////////////////////
    // WM_MOUSEMOVE                 //
    //                              //
    // This is where we change      //
    // the volume                   //
    //////////////////////////////////
    WM_LBUTTONDOWN,
    WM_NCLBUTTONDOWN,
    WM_MOUSEMOVE,
    WM_NCMOUSEMOVE:
    begin
      UpdateCursor();

      if (wParam = MK_LBUTTON ) then
      begin
        GetWindowRect(Window, r);
        GetCursorPos(P);

        // Are we on a slider?
        for i := 1 to 4 do
        begin
          if ((P.X >= r.Left + cfgSliderX[i]) and
             (P.X <= r.Left + cfgSliderX[i] + iSliderWidth) and
             (P.Y >= r.Top + cfgSliderY[i]) and
             (P.Y <= r.Top + cfgSliderY[i] + picSliderSkin.Height)) then
          begin
            case cfgOrientation of
              0: // Horizontal
              begin
                if (iSliderWidth>0) then
                begin
                  iVolume := (((P.X - (r.Left + cfgSliderX[i])) * 100) div iSliderWidth);
                  SetVol(mixers[cfgControl[i]], iVolume);
                end;
              end;
              1: // Vertical
              begin
                if (picSliderSkin.Height>0) then
                begin
                  iVolume := 100 - (((P.Y - (r.Top + cfgSliderY[i])) * 100) div picSliderSkin.Height);
                  SetVol(mixers[cfgControl[i]], iVolume);
                end;
              end;
            end;  //case
            // update the window and stop processing
            if mode=1 then DrawXP()
              else InvalidateRect(Wnd, nil, true);
            exit;
          end;
        end;  //for

      end;    //MK_LBUTTON
//      exit;
    end;      //WM_MOUSEMOVE


    //////////////////////////////////
    // WM_MOUSEWHEEL                //
    //                              //
    // May add wheel support later  //
    //////////////////////////////////
    WM_MOUSEWHEEL:
    begin
      //
    end;
  end;

  result := DefWindowProc(Window, Message, WParam, LParam);
end;



//////////////////////////////////////////////////////////////////
//   function ReadConfig                                        //
//                                                              //
//   Reads settings into variables                              //
//////////////////////////////////////////////////////////////////
function ReadConfig():bool;
var
  CFG:TCFG;
begin
  result:=false;

  OpenCFGr(AData.PluginsCFG, @CFG);

  FindSection(szClassName, 0, @CFG);


  GetCFGString(szSkin, '', cfgSkin, SizeOf(cfgSkin), @CFG);
  GetCFGString(szSliderSkin, '', cfgSliderSkin, SizeOf(cfgSliderSkin), @CFG);
  GetCFGString(szMuteSkin, '', cfgMuteSkin, SizeOf(cfgMuteSkin), @CFG);

  cfgX:=GetCFGInt(szXPos, 10, @CFG);
  cfgY:=GetCFGInt(szYPos, 10, @CFG);
  cfgLock:=GetCFGBool(szLock, FALSE, @CFG);
  cfgSliderFrameCount:=GetCFGInt(szSliderFrameCount, 0, @CFG);
  if cfgSliderFrameCount = 0 then cfgSliderFrameCount := 1;
  cfgOrientation:=GetCFGInt(szOrientation, 0, @CFG);

  cfgControl[1]:=GetCFGInt(szControl1, 1, @CFG);
  cfgControl[2]:=GetCFGInt(szControl2, 2, @CFG);
  cfgControl[3]:=GetCFGInt(szControl3, 3, @CFG);
  cfgControl[4]:=GetCFGInt(szControl4, 4, @CFG);


  cfgSliderX[1]:=GetCFGInt(szControl1X, 0, @CFG);
  cfgSliderX[2]:=GetCFGInt(szControl2X, 0, @CFG);
  cfgSliderX[3]:=GetCFGInt(szControl3X, 0, @CFG);
  cfgSliderX[4]:=GetCFGInt(szControl4X, 0, @CFG);

  cfgSliderY[1]:=GetCFGInt(szControl1Y, 0, @CFG);
  cfgSliderY[2]:=GetCFGInt(szControl2Y, 0, @CFG);
  cfgSliderY[3]:=GetCFGInt(szControl3Y, 0, @CFG);
  cfgSliderY[4]:=GetCFGInt(szControl4Y, 0, @CFG);

  cfgMuteX[1]:=GetCFGInt(szMute1X, 0, @CFG);
  cfgMuteX[2]:=GetCFGInt(szMute2X, 0, @CFG);
  cfgMuteX[3]:=GetCFGInt(szMute3X, 0, @CFG);
  cfgMuteX[4]:=GetCFGInt(szMute4X, 0, @CFG);

  cfgMuteY[1]:=GetCFGInt(szMute1Y, 0, @CFG);
  cfgMuteY[2]:=GetCFGInt(szMute2Y, 0, @CFG);
  cfgMuteY[3]:=GetCFGInt(szMute3Y, 0, @CFG);
  cfgMuteY[4]:=GetCFGInt(szMute4Y, 0, @CFG);


  CloseCFGr(@CFG);


  RtlZeroMemory(@picSkin, sizeof(TPicture));
  picSkin.FileName := cfgSkin;
  picSkin.Options:=PIC_NOCACHE;
  LoadImageEx(@picSkin);

  RtlZeroMemory(@picSliderSkin, sizeof(TPicture));
  picSliderSkin.FileName := cfgSliderSkin;
  picSliderSkin.Options:=PIC_NOCACHE;
  LoadImageEx(@picSliderSkin);

  RtlZeroMemory(@picMuteSkin, sizeof(TPicture));
  picMuteSkin.FileName := cfgMuteSkin;
  picMuteSkin.Options:=PIC_NOCACHE;
  LoadImageEx(@picMuteSkin);

  if (cfgSliderFrameCount <>0) then
    iSliderWidth := picSliderSkin.Width div cfgSliderFrameCount
  else
    iSliderWidth := 0;
    
  iMuteWidth := picMuteSkin.Width div 2;

  ZOrder := 1;     // Normal mode (to be changed at a later date)
  result:=true;
end;



//////////////////////////////////////////////////////////////////
//   procedure SaveConfig                                       //
//                                                              //
//   Saves X/Y position                                         //
//////////////////////////////////////////////////////////////////
procedure SaveConfig;
var
  CFG:TCFG;
  r:TRect;
begin
  OpenCFGw(AData.PluginsCFG, @CFG);
  FindSection(szClassName, SECTION_CREATE_ALWAYS, @CFG);
  if Wnd<>0 then
  begin
    GetWindowRect(Wnd, r);
    cfgX:=r.Left;
    cfgY:=r.Top;
    SetCFGInt(szXPos, cfgX, @CFG);
    SetCFGInt(szYPos, cfgY, @CFG);
  end;
  CloseCFGw(AData.PluginsCFG, false, @CFG);
end;


//////////////////////////////////////////////////////////////////
//   function InitVars                                          //
//                                                              //
//   Initializes Variables                                      //
//   Returns true if OS is Windows XP                           //
//////////////////////////////////////////////////////////////////
function InitVars():boolean;
var
 DC:hDC;
 hShell32: THandle;
begin
  result:=true;
  DC:= GetDC(0);
  if (isPng) then
  begin
    layered:= LayeredStyle(DC, 1)
  end
  else
  begin
    layered:= LayeredStyle(DC, 0);
  end;

  ReleaseDC(0, DC);
  hShell32:= GetModuleHandle('user32.dll');
  UpdateLayeredWindow := GetProcAddress(hShell32, 'UpdateLayeredWindow');
  if @UpdateLayeredWindow=nil then result:=false;
end;



//////////////////////////////////////////////////////////////////
//   procedure DrawSliders                                      //
//                                                              //
//   Draws the volume sliders to a device context               //
//////////////////////////////////////////////////////////////////
procedure DrawSliders(DC: hDC);
var
  i: integer;
  sliderDC: hDC;
  sliderBitmap: HBITMAP;
  iVolume: integer;
  iFrame: integer;
  BMP: TBITMAPINFOHEADER; 
  t,t1, oldBitmap, oldBitmap1, Old1:Hbitmap;
  p32, pmask:PChar;
 dcMemory, dcMemory1, DC1 : hDC;
begin
  if picSliderSkin.IconType = PICTURE_CORRUPT then exit;


  for i := 1 to 4 do
  begin
    //Skip controls that are set to "None"
    if cfgControl[i] = 0 then Continue;


    iVolume := GetVol(mixers[cfgControl[i]]);
    iFrame := iVolume * (cfgSliderFrameCount-1) div 100;

    if(picSliderSkin.Mask=0)and(picSliderSkin.Handle<>0)and(picSliderSkin.dwReserved<>0) then
    begin
      AlphaBlt(DC,cfgSliderX[i], cfgSliderY[i], iSliderWidth, picSliderSkin.Height, picSliderSkin.Handle,
        iSliderWidth * iFrame, iSliderWidth, picSliderSkin.Height, Pbyte(picSliderSkin.dwReserved));
    end
    else
    begin
      RtlZeroMemory(@bmp, sizeof(TBITMAPINFOHEADER));
      with bmp do
      begin
        biSize:= SizeOf(TBITMAPINFOHEADER);
        biWidth:= iSliderWidth;
        biHeight:= picSliderSkin.Height;
        biPlanes:= 1;
        biBitCount:= 32;
        biCompression:= BI_RGB;
      end;
      t:=CreateDIBSection(DC,PBITMAPINFO(@bmp)^, DIB_RGB_COLORS, pointer(p32), 0, 0);
      t1:=CreateDIBSection(DC,PBITMAPINFO(@bmp)^, DIB_RGB_COLORS, pointer(pMask), 0, 0);

      dcMemory:=CreateCompatibleDC(DC);
      oldBitmap:=SelectObject(dcMemory, t);
      dcMemory1:=CreateCompatibleDC(DC);
      oldBitmap1:=SelectObject(dcMemory1, t1);

      DC1:=CreateCompatibleDC(DC);
      Old1:=SelectObject(DC1, picSliderSkin.Mask);
      BitBlt(dcMemory1, 0,0, iSliderWidth, picSliderSkin.Height, DC1, iSliderWidth * iFrame,0, SRCCOPY);

      SelectObject(DC1, picSliderSkin.Handle);
      BitBlt(dcMemory, 0,0, iSliderWidth, picSliderSkin.Height, DC1, iSliderWidth * iFrame,0, SRCCOPY);
      SelectObject(DC1, old1);
      SelectObject(dcMemory, oldBitmap);
      SelectObject(dcMemory1, oldBitmap1);

      sliderDC:= CreateCompatibleDC(DC);
      sliderBitmap:= CreateCompatibleBitmap(DC, picSliderSkin.Width, picSliderSkin.Height);
      SelectObject(sliderDC, sliderBitmap);
      DrawPicture(sliderDC, sliderDC, 0, 0, @picSliderSkin);

      bitblt(DC,
             cfgSliderX[i],
             cfgSliderY[i],
             iSliderWidth,
             picSliderSkin.Height,
             sliderDC,
             iSliderWidth * iFrame,
             0,
             SRCCOPY
      );

      DeleteObject(t);
      DeleteObject(t1);
      DeleteObject(sliderBitmap);
      DeleteDC(dcMemory);
      DeleteDC(dcMemory1);
      DeleteDC(DC1);
      DeleteDC(sliderDC);
    end;
  end; //for
end;


//////////////////////////////////////////////////////////////////
//   procedure DrawMuteButtons                                  //
//                                                              //
//   Draws the mute buttons to a device context                 //
//////////////////////////////////////////////////////////////////
procedure DrawMuteButtons(DC: hDC);
var
  i: integer;
  muteDC: hDC;
  muteBitmap: HBITMAP;
  bMute: boolean;
  iFrame: integer;
  BMP: TBITMAPINFOHEADER;
  t,t1, oldBitmap, oldBitmap1, Old1:Hbitmap;
  p32, pmask:PChar;
 dcMemory, dcMemory1, DC1 : hDC;
begin
  if picMuteSkin.IconType = PICTURE_CORRUPT then exit;

  for i := 1 to 4 do
  begin
    //Skip controls that are set to "None"
    if cfgControl[i] = 0 then Continue;

    bMute := GetVolumeMute(mixers[cfgControl[i]]);
    if bMute then iFrame:=1 else iFrame:=0;

    if(picMuteSkin.Mask=0)and(picMuteSkin.Handle<>0)and(picMuteSkin.dwReserved<>0) then
    begin
      AlphaBlt(DC,cfgMuteX[i], cfgMuteY[i], iMuteWidth, picMuteSkin.Height, picMuteSkin.Handle,
        iMuteWidth * iFrame, iMuteWidth, picMuteSkin.Height, Pbyte(picMuteSkin.dwReserved));
    end
    else
    begin
      RtlZeroMemory(@bmp, sizeof(TBITMAPINFOHEADER));
      with bmp do
      begin
        biSize:= SizeOf(TBITMAPINFOHEADER);
        biWidth:= iMuteWidth;
        biHeight:= picMuteSkin.Height;
        biPlanes:= 1;
        biBitCount:= 32;
        biCompression:= BI_RGB;
      end;
      t:=CreateDIBSection(DC,PBITMAPINFO(@bmp)^, DIB_RGB_COLORS, pointer(p32), 0, 0);
      t1:=CreateDIBSection(DC,PBITMAPINFO(@bmp)^, DIB_RGB_COLORS, pointer(pMask), 0, 0);

      dcMemory:=CreateCompatibleDC(DC);
      oldBitmap:=SelectObject(dcMemory, t);
      dcMemory1:=CreateCompatibleDC(DC);
      oldBitmap1:=SelectObject(dcMemory1, t1);

      DC1:=CreateCompatibleDC(DC);
      Old1:=SelectObject(DC1, picMuteSkin.Mask);
      BitBlt(dcMemory1, 0,0, iMuteWidth, picMuteSkin.Height, DC1, iMuteWidth * iFrame,0, SRCCOPY);

      SelectObject(DC1, picMuteSkin.Handle);
      BitBlt(dcMemory, 0,0, iMuteWidth, picMuteSkin.Height, DC1, iMuteWidth * iFrame,0, SRCCOPY);
      SelectObject(DC1, old1);
      SelectObject(dcMemory, oldBitmap);
      SelectObject(dcMemory1, oldBitmap1);

      muteDC:= CreateCompatibleDC(DC);
      muteBitmap:= CreateCompatibleBitmap(DC, picMuteSkin.Width, picMuteSkin.Height);
      SelectObject(muteDC, muteBitmap);
      DrawPicture(muteDC, muteDC, 0, 0, @picMuteSkin);


      bitblt(DC,
             cfgMuteX[i],
             cfgMuteY[i],
             iMuteWidth,
             picMuteSkin.Height,
             muteDC,
             iMuteWidth * iFrame,
             0,
             SRCCOPY
      );

      DeleteObject(t);
      DeleteObject(t1);
      DeleteObject(muteBitmap);
      DeleteDC(dcMemory);
      DeleteDC(dcMemory1);
      DeleteDC(DC1);
      DeleteDC(muteDC);
    end;

  end; //for
end;





//////////////////////////////////////////////////////////////////
//   procedure DrawXP                                           //
//                                                              //
//   Draws the layered window                                   //
//   Does not need to be called from WM_PAINT, layered windows  //
//   only need to be drawn when they change                     //
//////////////////////////////////////////////////////////////////
procedure DrawXP();
var
  memDC: hDC;
  memBmp: HBitmap;
  OldmemBmp:HGDIOBJ;
  ptWindowScreenPosition,
  ptSrc:Tpoint;
  szWindow:TSIZE;
  blendPixelFunction:TBLENDFUNCTION;
  DC:hDC;
  ps: TPaintStruct;
begin
  ptWindowScreenPosition.X := cfgX;
  ptWindowScreenPosition.Y := cfgY;
  ptSrc.X := 0;
  ptSrc.Y := 0;
  blendPixelFunction.BlendOp := AC_SRC_OVER;
  blendPixelFunction.BlendFlags := 0;
  blendPixelFunction.SourceConstantAlpha := 255;
  blendPixelFunction.AlphaFormat := AC_SRC_ALPHA;
  szWindow.cx := picSkin.Width;
  szWindow.cy := picSkin.Height;
  DC:= GetDC(0);
  memBmp:=CreateCompatibleBitmap(DC, picSkin.Width, picSkin.Height);
  memDC:=CreateCompatibleDC(DC);
  OldmemBmp:=SelectObject(memDC, memBmp);
  drawpicture(memDC, memDC, 0, 0, @picSkin);
  DrawSliders(memDC);
  DrawMuteButtons(memDC);
  BeginPaint(Wnd, ps);
  EndPaint(Wnd, ps);
  UpdateLayeredWindow(Wnd, DC, @ptWindowScreenPosition,
                      @szWindow, memDC, @ptSrc, 0, @blendPixelFunction, ULW_ALPHA);
  SelectObject(memDC, OldmemBmp);
  DeleteObject(memBmp);
  DeleteObject(OldmemBmp);
  DeleteDC(memDC);
  ReleaseDC(0, DC);
  DeleteDC(DC);
end;

//////////////////////////////////////////////////////////////////
//   procedure TryMakeMask                                      //
//                                                              //
//   Not sure what it does, it was taken from amonitor          //
//////////////////////////////////////////////////////////////////
procedure TryMakeMask(p:PPicture);
var
  BMP: TBITMAPINFOHEADER;
  p32:PChar;
  dcMemory,
  DC:hDC;
  oldBitmap:Hbitmap;
  bmplen, cx,x,y:integer;
  Row1,
  Row2:Pchar;

begin
  DC:=GetDC(0);
  dcMemory:=CreateCompatibleDC(DC);
  with bmp do
  begin
    biSize:= SizeOf(TBITMAPINFOHEADER);
    biWidth:= p.Width;
    biHeight:= p.Height;
    biPlanes:= 1;
    biBitCount:= 32;
    biCompression:= BI_RGB;
  end;
  p.Mask:=CreateDIBSection(dcMemory,PBITMAPINFO(@bmp)^, DIB_RGB_COLORS, pointer(p32), 0, 0);
  oldBitmap:=SelectObject(dcMemory, p.Mask);

  bmplen:=p.Width*4;//BytesPerScanline(p.Width, 32, 32);
  Row1 :=@p32[0];
  Row2 :=pointer(p.dwReserved);

  for y:=0 to p.Height-1 do
   begin
     for x:=0 to p.Width-1 do
     begin
      cx := 4*x;
      if Row2[cx+3]<#3 then
      begin
        Row1[cx+3] := Char(255);
        Row1[cx+2] := Char(255);
        Row1[cx+1] := Char(0);
        Row1[cx] := Char(255);
      end;  
    end;
     inc(Row1,bmplen);
     inc(Row2,bmplen);     
   end;
  SelectObject(dcMemory, oldBitmap);
  ReleaseDC(0, DC);
end;


//////////////////////////////////////////////////////////////////
//   function InitGlobalModule                                  //
//                                                              //
//////////////////////////////////////////////////////////////////
procedure InitGlobalModule(const AstonData:PAstonData);stdcall;
var
  WindowClass:TWndClass;
begin
  RtlZeroMemory(@WindowClass, sizeOf(TWndClass));
  WindowClass.style:=CS_HREDRAW or CS_VREDRAW;
  WindowClass.hCursor := LoadCursor(0, IDC_ARROW);
  WindowClass.hInstance := hInstance;
  WindowClass.lpfnWndProc:=@WindowProc;
  WindowClass.lpszClassName:= szClassName;
  if RegisterClass(WindowClass) = 0 then exit;
  RtlMoveMemory(@AData, AstonData, SizeOf(TAstonData));


  if not ReadConfig() then exit;
  if picSkin.IconType = PICTURE_BMP_ALPHA  then isPNG:=true else isPNG:=false;
  isXp:=initVars();
  if isPNG and (not isXp) then ZOrder:=0;
  case ZOrder of

  0: Wnd:=CreateWindowEx(0, szClassName, nil,
                                   WS_CHILD or WS_CLIPSIBLINGS
                                   or WS_CLIPCHILDREN,
                                   cfgX, cfgY, picSkin.Width, picSkin.Height,
                                   AData.Desktop, 0, hInstance, nil);
  1: Wnd:= CreateWindowEx(WS_EX_TOOLWINDOW or layered,
                                szClassName, nil, WS_POPUP,
                                cfgX, cfgY, picSkin.Width, picSkin.Height,
                                0, 0, hInstance, nil);
  2: Wnd:= CreateWindowEx(WS_EX_TOPMOST or WS_EX_TOOLWINDOW
                                or layered,
                                szClassName, nil, WS_POPUP,
                                cfgX, cfgY, picSkin.Width, picSkin.Height,
                                0, 0, hInstance, nil);
  end;

  if Wnd=0 then exit;
  SetWindowLong(Wnd, GWL_USERDATA, magicDWord);
  bd.cbSize:=SizeOf(ShellAPI.TAPPBARDATA);
  bd.uCallbackMessage:=CM_APPBAR;
  bd.hWnd:=Wnd;
  SHAppbarMessage(ABM_NEW, bd);


  with AData.Node^ do
  begin
    Wnd:=Wnd;
    if ZOrder=2 then NodeType:= NodeType or NODE_WM_DISPLAYCHANGE_REGISTER;
  end;


  if (not isPNG)or(not isXp)or(ZOrder=0) then
  begin
    if isPNG then
    begin
      TryMakeMask(@picSkin);
      SetWindowRgn(Wnd, BitmapToRegion(picSkin.Mask, RGB(255,0,255),0,0), True);
      DeleteObject(picSkin.Mask);
    end
    else
    begin
      SetWindowRgn(Wnd, BitmapToRegion(picSkin.Mask, RGB(255,255,255),0,0), True);
    end;
    mode:=0;
  end
  else
  begin
    mode:=1;
    DrawXP();
  end;

  GetClientRect(Wnd, ClientRC);
  ShowWindow(Wnd, SW_SHOW);

  Timer := SetTimer(Wnd, 0, 250, nil);
end;

procedure FreePic(p:PPicture);
begin
  if p.Shared then exit;
  if p.IconType = PICTURE_BMP_ALPHA then
  begin
    if p.Handle<>0 then DeleteObject(p.Handle);
  end
   else
  begin
    if p.Handle<>0 then DeleteObject(p.Handle);
    if p.Mask<>0 then DeleteObject(p.Mask);
  end;
end;

procedure DoneModule; stdcall;
begin
  KillTimer(Wnd, Timer);
  FreePic(@picSkin);
  FreePic(@picSliderSkin);
  FreePic(@picMuteSkin);
  if Wnd<>0 then
  begin
    DestroyWindow(Wnd);
    Wnd:=0;
  end;
  UnregisterClass(pchar(szClassName), hInstance);
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

function GetPluginInfo:PPluginInfo;stdcall;
begin
  PluginInfo.cbSize:= SizeOf(TPluginInfo);
  PluginInfo.szName:= szClassName;
  PluginInfo.szDescription:= szhelp;
  PluginInfo.szSection:= szClassName;
  PluginInfo.nKeyCount:= KeyCount;
  PluginInfo.Keys:= @Keys;
  Keys[8].res2:=integer(@vOrientations);
  Keys[10].res2:=integer(@vControls);
  Keys[16].res2:=integer(@vControls);
  Keys[22].res2:=integer(@vControls);
  Keys[28].res2:=integer(@vControls);
  result:= @PluginInfo;
end;

{---------------------------------------------------------------------}
{---------------------------------------------------------------------}

//////////////////////////////////////////////////////////////////
//   function AstonMB                                           //
//                                                              //
//   Shows Message Box                                          //
//////////////////////////////////////////////////////////////////
procedure AstonMB(sMessage: string);
begin
  if (GetAsyncKeyState(VK_CONTROL)and $8000)=0 then
  begin
    SendMessage(AData.MainWindow, CM_ENTERMODAL, 0, 0);
    MessageBox(0, pchar(sMessage), pchar('zVolume'), MB_OK or MB_TOPMOST);
    SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0, 0);
  end;
end;

exports
  InitGlobalModule,
  DoneModule,
  GetPluginInfo;
end.
